/*
Created by: X
http://www.createdbyx.com/

XNAContentCode is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace XNAContentCode
{
    public class ContentItem
    {
        private Dictionary<string, string> values = new Dictionary<string, string>();
        private System.Collections.Generic.Dictionary<string, ContentItem> children = new Dictionary<string, ContentItem>();


        public System.Collections.Generic.Dictionary<string, ContentItem> Children
        {
            get { return children; }
            set { children = value; }
        }

        public Dictionary<string, string> Items
        {
            get { return values; }
            set { values = value; }
        }


        public override string ToString()
        {
            string data = string.Empty;
            foreach (string ci in this.children.Keys)
            {
                data += "public static class " + ci.Replace(" ", "_") + "\r\n{\r\n\r\n";
                data += this.children[ci].ToString();
                data += "}\r\n\r\n";
            }

            foreach (KeyValuePair<string, string> val in this.values)
            {
                string name;
                name = ((string)val.Key).Replace(" ", "_");
                
                string tmp;
                tmp = (string)val.Value;// this.values[val];
                tmp = tmp.Replace(" ", "_");
                tmp = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(tmp), name);
               
                data += "public const string " + name + " = @\"" + tmp + "\";\r\n";
            }

            return data;
        }

        public void Add(string name, string path)
        {
            this.DoAdd(name, path, path);

        }

        private void DoAdd(string name, string path, string fullPath)
        {
            string[] parts = path.Split(System.IO.Path.DirectorySeparatorChar);
            if (parts.Length == 1)
            {
                this.values.Add(name, fullPath);
            }
            else
            {
                if (this.children.ContainsKey(parts[0]))
                {
                    this.children[parts[0]].DoAdd(name,
                        string.Join(System.IO.Path.DirectorySeparatorChar.ToString(), parts, 1, parts.Length - 1),
                        fullPath);
                }
                else
                {
                    ContentItem ci = new ContentItem();
                    ci.DoAdd(name,
                        string.Join(System.IO.Path.DirectorySeparatorChar.ToString(), parts, 1, parts.Length - 1),
                        fullPath);
                    this.children.Add(parts[0], ci);
                }
            }
        }
    }
}
