/*
Created by: X
http://www.createdbyx.com/

XNAContentCode is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;

namespace XNAContentCode
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args != null && args.Length >= 2)
            {
                if (File.Exists(args[0]) == true)
                {
                    // read file data
                    XmlDocument doc = new XmlDocument();
                    try
                    {
                        doc.Load(args[0]);
                    }
                    catch (Exception)
                    {

                        Environment.Exit(-1);
                    }

                    string data = string.Empty;
                    ContentItem root = new ContentItem();

                    // parse itemgrtoup nodes
                    foreach (XmlNode node in doc.DocumentElement.ChildNodes)
                    {
                        if (string.Compare(node.Name, "itemgroup", true) == 0)
                        {
                            // parse content nodes
                            //  XmlNodeList contentNodes = node.SelectNodes("Content");
                            foreach (XmlNode cnode in node.ChildNodes)
                            {
                                if (string.Compare(cnode.Name, "content", true) == 0)
                                {
                                    XmlNode xnanode = cnode["XNAUseContentPipeline"];
                                    if (xnanode != null && string.Compare(xnanode.InnerText, bool.TrueString, true) == 0)
                                    {
                                        XmlNode nameNode = cnode["Name"];
                                        XmlNode sourceFile = cnode.Attributes.GetNamedItem("Include");

                                        root.Add(nameNode.InnerText, sourceFile.InnerText);
                                    }
                                }
                            }
                        }
                    }

                    // construct output content
                    data = root.ToString();

                    // generate final output code
                    data = GetHeaderComments(args) + data + GetFooterComments(args);

                    // save data to file
                    File.WriteAllText(args[1], data);
                }
            }
            else
            {
                Environment.Exit(-1);
            }
        }

        private static string GetFooterComments(string[] args)
        {
            string data = string.Empty;
            if (args.Length >= 4)
            {
                data = System.IO.File.ReadAllText(args[3]);
            }
            return data;
        }

        static string GetHeaderComments(string[] args)
        {
                        string data = string.Empty;
                        if (args.Length >= 3)
                        {
                            data = System.IO.File.ReadAllText(args[2]);
                        }
            //data = "// This code is generated by the XNAContentCode project!\r\n";
            //data += "//Any changes made to this code will be lost when SMLOP Heroes is compiled.\r\n\r\n";
            //data += "/*" + "\r\n";
            //data += "Created by: X" + "\r\n";
            //data += "http://www.createdbyx.com/" + "\r\n";
            //data += "\r\n";
            //data += "The game SMLOP: Heroes is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada" + "\r\n";
            //data += "http://creativecommons.org/licenses/by-nc-sa/2.5/ca/" + "\r\n";
            //data += "*/" + "\r\n";
            //data += "using System;" + "\r\n";
            //data += "using System.Collections.Generic;" + "\r\n";
            //data += "using System.Text;" + "\r\n";
            //data += "\r\n";
            //data += "namespace SMLOP_Heroes" + "\r\n";
            //data += "{" + "\r\n";
            //data += "public static class Content\r\n{\r\n";
            return data;            
        }
   }
}